#import "../scsi_cd.subproj/cd_toc.h"

/* some interesting "key" values: */
#define CDKEY_05min  108000000
#define CDKEY_10min  216000000
#define CDKEY_15min  324000000
#define CDKEY_20min  432000000
#define CDKEY_25min  540000000
#define CDKEY_30min  648000000
#define CDKEY_35min  756000000
#define CDKEY_37min  799200000
#define CDKEY_38min  820800000
#define CDKEY_40min  864000000
#define CDKEY_42min  907200000
#define CDKEY_43min  928800000
#define CDKEY_45min  972000000
#define CDKEY_50min 1080000000
#define CDKEY_55min 1188000000
#define CDKEY_60min 1296000000


/* used to define routines that fillTocTitles will call, internally */
typedef void fillrtn( struct cd_toc *, u_int);

fillrtn filltoc04;  /* 04 tracks */
fillrtn filltoc05;  /* 05 tracks */
fillrtn filltoc06;  /* 06 tracks */
fillrtn filltoc07;  /* 07 tracks */
fillrtn filltoc08_00;  /* 08 tracks, under 40 minutes */
fillrtn filltoc08_40;  /* 08 tracks, 40 - 44:59:59... minutes */
fillrtn filltoc08_45;  /* 08 tracks, >= 45 minutes */
fillrtn filltoc09_00;  /* 09 tracks, under 40 minutes */
fillrtn filltoc09_40;  /* 09 tracks, 40 - 44:59:59... minutes */
fillrtn filltoc09_45;  /* 09 tracks, 45 - 54:59:59... minutes */
fillrtn filltoc09_55;  /* 09 tracks, >= 55 minutes */
fillrtn filltoc10_00;  /* 10 tracks, under 35 minutes */
fillrtn filltoc10_35;  /* 10 tracks, 35 - 37:59:59... minutes */
fillrtn filltoc10_38;  /* 10 tracks, 38 - 39:59:59... minutes */
fillrtn filltoc10_40;  /* 10 tracks, 40 - 42:59:59... minutes */
fillrtn filltoc10_43;  /* 10 tracks, 43 - 44:59:59... minutes */
fillrtn filltoc10_45;  /* 10 tracks, 45 - 49:59:59... minutes */
fillrtn filltoc10_50;  /* 10 tracks, >= 50 minutes */
fillrtn filltoc11_00;  /* 11 tracks, under 40 minutes */
fillrtn filltoc11_40;  /* 11 tracks, 40 - 44:59:59... minutes */
fillrtn filltoc11_45;  /* 11 tracks, 45 - 49:59:59... minutes */
fillrtn filltoc11_50;  /* 11 tracks, 50 - 59:59:59... minutes */
fillrtn filltoc11_60;  /* 11 tracks, >= 60 minutes */
fillrtn filltoc12_00;  /* 12 tracks, under 45 minutes */
fillrtn filltoc12_45;  /* 12 tracks, 45 - 49:59:59... minutes */
fillrtn filltoc12_50;  /* 12 tracks, 50 - 59:59:59... minutes */
fillrtn filltoc12_60;  /* 12 tracks, >= 60 minutes */
fillrtn filltoc13_00;  /* 13 tracks, under 50 minutes */
fillrtn filltoc13_50;  /* 13 tracks, 50 - 59:59:59... minutes */
fillrtn filltoc13_60;  /* 13 tracks, >= 60 minutes */
fillrtn filltoc14_00;  /* 14 tracks, under 60 minutes */
fillrtn filltoc14_60;  /* 14 tracks, >= 60 minutes */
fillrtn filltoc15;  /* 15 tracks */
fillrtn filltoc16;  /* 16 tracks */
fillrtn filltoc17;  /* 17 tracks */
fillrtn filltoc18;  /* 18 tracks */
fillrtn filltoc19;  /* 19 tracks */
fillrtn filltoc20;  /* 20 tracks */
fillrtn filltoc21;  /* 21 tracks */
fillrtn filltoc22;  /* 22-25 tracks */
fillrtn filltoc26;  /* 26-49 tracks */
fillrtn filltoc50;  /* 50 or more tracks */

/* SET_CDtt  -  set CD track-title
 * a simple macro to make track-title entries easier to read.
 * currently it does nothing with the TIME field.
 *
 * Note that you can greatly reduce the size of the CD_DBase
 * modules by defining setTT to do absolutely nothing...
 * This would result in a database that has all the performer
 * and disc-title information, but none of the track-titles.
 */
#define SET_CDtt(TRACK,TIME,TITLE) tocPtr->info[TRACK].trackTitle = TITLE

/* The following can #define some variables to shrink the size of
 * the fillrtn's
 */
#import "SkipSongs.h"
