/*
 * Uncommenting any of the following will cause song-titles for the
 * matching artist to be skipped over.  The routines will still
 * recognize the matching CD's, and will give the artist and CD-title
 * information, but it won't give song-title information.
 *
 * This should allow one to dramatically shrink the size of the
 * CD_DBase object module without turning off *all* song titles.
 * (to turn off all song titles, redefine the SET_CDtt macro to
 * do nothing)
 *
 * The value given on the #define is not used by anything in the
 * program.  It just indicates aprox. how many CDs/songs would be
 * effected if the given symbol is defined.
 */

// #define SKIPSONGS_Al_Stewart                             13-145
// #define SKIPSONGS_Alan_Parsons_Project                   22-242
// #define SKIPSONGS_Amy_Grant                               9-106
// #define SKIPSONGS_Andy_Pickford                           6-59
// #define SKIPSONGS_Art_of_Noise                            3-27
// #define SKIPSONGS_Barclay_James_Harvest                  18-176
// #define SKIPSONGS_Bee_Gees                                4-71
// #define SKIPSONGS_Billy_Joel                             19-209
// #define SKIPSONGS_Bob_Dylan                              29-351
// #define SKIPSONGS_Bruce_Springsteen                      16-178
// #define SKIPSONGS_Camel                                   4-48
// #define SKIPSONGS_Chet_Atkins                            12-215
// #define SKIPSONGS_Chicago                                 2-25
// #define SKIPSONGS_Christopher_Franke                      5-67
// #define SKIPSONGS_David_Bowie                             3-45
// #define SKIPSONGS_Dire_Straits                           10-82
// #define SKIPSONGS_Don_Henley                              4-45
// #define SKIPSONGS_Dream_Theater                           3-27
// #define SKIPSONGS_Eagles                                 12-118
// #define SKIPSONGS_Electric_Light_Orchestra               12-155
// #define SKIPSONGS_Elton_John                             66-749
// #define SKIPSONGS_Elvis_Costello                          5-90
// #define SKIPSONGS_Eric_Clapton                           12-130
// #define SKIPSONGS_Fleetwood_Mac                           9-143
// #define SKIPSONGS_Foreigner                               1-10
// #define SKIPSONGS_Gandalf                                 2-20
// #define SKIPSONGS_Genesis                                 6-56
// #define SKIPSONGS_George_Beverly_Shea                     2-40
// #define SKIPSONGS_George_Harrison                         6-74
// #define SKIPSONGS_Gordon_Lightfoot                       10-152
// #define SKIPSONGS_Happy_Rhodes                            4-54
// #define SKIPSONGS_Heart                                   9-99
// #define SKIPSONGS_Hootie_N_The_Blowfish                   2-26
// #define SKIPSONGS_Icehouse                               13-145
// #define SKIPSONGS_Jackson_Browne                         11-103
// #define SKIPSONGS_Jean_Michel_Jarre                       6-43
// #define SKIPSONGS_Jeff_Beck                               7-60
// #define SKIPSONGS_John_Fahey                              2-46
// #define SKIPSONGS_John_Lennon                             2-27
// #define SKIPSONGS_John_Mellencamp                         9-106
// #define SKIPSONGS_Johnny_Horton                           6-160
// #define SKIPSONGS_Kingston_Trio                           4-107
// #define SKIPSONGS_Klaus_Schulze                           4-11
// #define SKIPSONGS_Kraftwerk                               4-39
// #define SKIPSONGS_Led_Zeppelin                           25-287
// #define SKIPSONGS_Linda_Ronstadt                          3-31
// #define SKIPSONGS_Mannheim_Steamroller                    4-49
// #define SKIPSONGS_Mark_Shreeve                            6-56
// #define SKIPSONGS_Mary_Chapin_Carpenter                   6-69
// #define SKIPSONGS_Michael_Garrison                       13-134
// #define SKIPSONGS_Mike_Oldfield                          30-245
// #define SKIPSONGS_Moody_Blues                            27-330
// #define SKIPSONGS_Nanci_Griffith                         12-154
// #define SKIPSONGS_Neil_Diamond                            8-119
// #define SKIPSONGS_Neil_Young                             23-240
// #define SKIPSONGS_Orchestral_Manoeuvres_in_the_Dark      10-110
// #define SKIPSONGS_Pat_Benatar                            15-178
// #define SKIPSONGS_Paul_McCartney                          2-38
// #define SKIPSONGS_Paul_Simon                              6-68
// #define SKIPSONGS_Peter_Mergener                          5-46
// #define SKIPSONGS_Phil_Collins                            5-56
// #define SKIPSONGS_Pink_Floyd                             60-579
// #define SKIPSONGS_Police                                  6-108
// #define SKIPSONGS_Porcupine_Tree                          2-22
// #define SKIPSONGS_Queen                                  15-180
// #define SKIPSONGS_Renaissance                            26-190
// #define SKIPSONGS_Ringo_Starr                             4-47
// #define SKIPSONGS_Shadowfax                               1-10
// #define SKIPSONGS_Shamall                                 5-51
// #define SKIPSONGS_Simon_and_Garfunkel                     3-58
// #define SKIPSONGS_Sniff_n_the_Tears                       4-40
// #define SKIPSONGS_Software                               11-91
// #define SKIPSONGS_Statler_Brothers                        1-22
// #define SKIPSONGS_Steely_Dan                              6-89
// #define SKIPSONGS_Stevie_Wonder                           4-37
// #define SKIPSONGS_Supertramp                             10-89
// #define SKIPSONGS_Swing_Out_Sister                        4-52
// #define SKIPSONGS_Tangerine_Dream                        42-336
// #define SKIPSONGS_The_Beatles                            21-408
// #define SKIPSONGS_The_Call                                6-71
// #define SKIPSONGS_The_Cars                                2-40
// #define SKIPSONGS_The_Fixx                                5-54
// #define SKIPSONGS_The_Yardbirds                           5-106
// #define SKIPSONGS_Tom_Petty                              23-286
// #define SKIPSONGS_U2                                     13-136
// #define SKIPSONGS_VA_Tee_Vee_Toons                        7-455
// #define SKIPSONGS_Weird_Al_Yankovic                       8-96
// #define SKIPSONGS_Yes                                     4-33
